DevExtreme v25.2 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

JavaScript/jQuery Charts - Custom Axis Position

The Chart component initially displays axes along pane borders. Several other predefined axis layout properties are available. In this demo, the customPosition property is used to move each axis, so that it is displayed on the specified value of another axis. When you position the argument axis, use values from the value axis (in the same type and format) and vice versa.

Backend API
$(() => { const chart = $('#chart').dxChart({ dataSource: generateDataSource(), commonSeriesSettings: { type: 'scatter', }, series: [{ argumentField: 'x1', valueField: 'y1', }, { argumentField: 'x2', valueField: 'y2', point: { symbol: 'triangleDown', }, }], argumentAxis: { customPosition: 0, visualRange: [-20, 20], offset: 0, }, valueAxis: { customPosition: 0, endOnTick: false, visualRange: [-20, 20], offset: 0, }, legend: { visible: false, }, }).dxChart('instance'); $('#argumentCustomPosition').dxNumberBox({ value: 0, showSpinButtons: true, inputAttr: { 'aria-label': 'Argument Custom Position' }, onValueChanged(e) { chart.option('argumentAxis.customPosition', e.value); }, }); $('#argumentOffset').dxNumberBox({ value: 0, showSpinButtons: true, inputAttr: { 'aria-label': 'Argument Offset' }, onValueChanged(e) { chart.option('argumentAxis.offset', e.value); }, }); $('#valueCustomPosition').dxNumberBox({ value: 0, showSpinButtons: true, inputAttr: { 'aria-label': 'Value Custom Position' }, onValueChanged(e) { chart.option('valueAxis.customPosition', e.value); }, }); $('#valueOffset').dxNumberBox({ value: 0, showSpinButtons: true, inputAttr: { 'aria-label': 'Value Offset' }, onValueChanged(e) { chart.option('valueAxis.offset', e.value); }, }); });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml" lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.7/css/dx.light.css" /> <script src="js/dx.all.js?v=25.2.7"></script> <script src="data.js"></script> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="chart"></div> <div class="options"> <div class="caption">Options</div> <div class="common"> <div class="block left"> <span>Argument Axis</span> <div class="option"> <span>Custom position:</span> <div id="argumentCustomPosition"></div> </div> <div class="option"> <span>Offset:</span> <div id="argumentOffset"></div> </div> </div> <div class="block right"> <span>Value Axis</span> <div class="option"> <span>Custom position:</span> <div id="valueCustomPosition"></div> </div> <div class="option"> <span>Offset:</span> <div id="valueOffset"></div> </div> </div> </div> </div> </div> </body> </html>
.options { padding: 20px; margin-top: 20px; background-color: rgba(191, 191, 191, 0.15); } .option { margin-top: 10px; display: flex; align-items: center; justify-content: space-between; } .option > span { margin-right: 20px; } .caption { font-size: 18px; font-weight: 700; } .option > .dx-numberbox { width: 90px; margin-left: auto; } .common { width: 488px; } .block { vertical-align: middle; margin-top: 10px; } .left { display: inline-block; } .right { float: right; } .block > span { font-size: 18px; font-weight: 500; }
function generateDataSource() { let x1; let x2; let y1; let y2; let i; const ds = []; for (i = 0; i < 20; i += 1) { x1 = random(5, 15); y1 = random(5, 15); ds.push({ x1, y1, x2, y2, }); } for (i = 0; i < 20; i += 1) { x2 = random(5, 15); y2 = random(-15, -5); ds.push({ x1, y1, x2, y2, }); } for (i = 0; i < 20; i += 1) { x2 = random(-15, -5); y2 = random(5, 15); ds.push({ x1, y1, x2, y2, }); } for (i = 0; i < 20; i += 1) { x1 = random(-15, -5); y1 = random(-15, -5); ds.push({ x1, y1, x2, y2, }); } return ds; } function random(min, max) { return Math.floor(Math.random() * (max - min + 1)) + min; }

Regardless of which automatic axis layout type you use, the Chart Control allows you to apply manual offsets. Specify the offset property in pixels to keep the axis position unchanged when users scroll or zoom the Chart data. The offset property shifts the axis from the specified position as follows:

  • If the axis is horizontal, a negative offset shifts the axis to the top, a positive offset shifts it to the bottom.

  • If the axis is vertical, a negative offset shifts the axis to the left, a positive offset shifts it to the right.

In this demo, you can use controls under the Chart to change the customPosition and offset properties for both axes.

DevExtreme v25.2 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

React Charts - Custom Axis Position

The Chart component initially displays axes along pane borders. Several other predefined axis layout properties are available. In this demo, the customPosition property is used to move each axis, so that it is displayed on the specified value of another axis. When you position the argument axis, use values from the value axis (in the same type and format) and vice versa.

Backend API
import React, { useCallback, useState } from 'react'; import NumberBox, { type NumberBoxTypes } from 'devextreme-react/number-box'; import { Chart, CommonSeriesSettings, Series, Point, ArgumentAxis, ValueAxis, Legend, } from 'devextreme-react/chart'; import { generateDataSource, customPositionLabel, offsetLabel } from './data.ts'; const dataSource = generateDataSource(); const defaultVisualRange = [-20, 20]; function App() { const [argumentCustomPosition, setArgumentCustomPosition] = useState(0); const [argumentOffset, setArgumentOffset] = useState(0); const [valueCustomPosition, setValueCustomPosition] = useState(0); const [valueOffset, setValueOffset] = useState(0); const changeArgumentPosition = useCallback((e: NumberBoxTypes.ValueChangedEvent) => { setArgumentCustomPosition(e.value); }, [setArgumentCustomPosition]); const changeArgumentOffset = useCallback((e: NumberBoxTypes.ValueChangedEvent) => { setArgumentOffset(e.value); }, [setArgumentOffset]); const changeValuePosition = useCallback((e: NumberBoxTypes.ValueChangedEvent) => { setValueCustomPosition(e.value); }, [setValueCustomPosition]); const changeValueOffset = useCallback((e: NumberBoxTypes.ValueChangedEvent) => { setValueOffset(e.value); }, [setValueOffset]); return ( <div> <Chart id="chart" dataSource={dataSource}> <CommonSeriesSettings type='scatter' /> <Series argumentField='x1' valueField='y1' /> <Series argumentField='x2' valueField='y2'> <Point symbol='triangleDown' /> </Series> <ArgumentAxis defaultVisualRange={defaultVisualRange} customPosition={argumentCustomPosition} offset={argumentOffset} /> <ValueAxis defaultVisualRange={defaultVisualRange} customPosition={valueCustomPosition} offset={valueOffset} endOnTick={false} /> <Legend visible={false} /> </Chart> <div className='options'> <div className='caption'>Options</div> <div className="common"> <div className='block left'> <span>Argument Axis</span> <div className='option'> <span>Custom position:</span> <NumberBox value={argumentCustomPosition} showSpinButtons={true} inputAttr={customPositionLabel} onValueChanged={changeArgumentPosition} /> </div> <div className='option'> <span>Offset:</span> <NumberBox value={argumentOffset} showSpinButtons={true} inputAttr={offsetLabel} onValueChanged={changeArgumentOffset} /> </div> </div> <div className='block right'> <span>Value Axis</span> <div className='option'> <span>Custom position:</span> <NumberBox value={valueCustomPosition} showSpinButtons={true} inputAttr={customPositionLabel} onValueChanged={changeValuePosition} /> </div> <div className='option'> <span>Offset:</span> <NumberBox value={valueOffset} showSpinButtons={true} inputAttr={offsetLabel} onValueChanged={changeValueOffset} /> </div> </div> </div> </div> </div> ); } export default App;
import React, { useCallback, useState } from 'react'; import NumberBox from 'devextreme-react/number-box'; import { Chart, CommonSeriesSettings, Series, Point, ArgumentAxis, ValueAxis, Legend, } from 'devextreme-react/chart'; import { generateDataSource, customPositionLabel, offsetLabel } from './data.js'; const dataSource = generateDataSource(); const defaultVisualRange = [-20, 20]; function App() { const [argumentCustomPosition, setArgumentCustomPosition] = useState(0); const [argumentOffset, setArgumentOffset] = useState(0); const [valueCustomPosition, setValueCustomPosition] = useState(0); const [valueOffset, setValueOffset] = useState(0); const changeArgumentPosition = useCallback( (e) => { setArgumentCustomPosition(e.value); }, [setArgumentCustomPosition], ); const changeArgumentOffset = useCallback( (e) => { setArgumentOffset(e.value); }, [setArgumentOffset], ); const changeValuePosition = useCallback( (e) => { setValueCustomPosition(e.value); }, [setValueCustomPosition], ); const changeValueOffset = useCallback( (e) => { setValueOffset(e.value); }, [setValueOffset], ); return ( <div> <Chart id="chart" dataSource={dataSource} > <CommonSeriesSettings type="scatter" /> <Series argumentField="x1" valueField="y1" /> <Series argumentField="x2" valueField="y2" > <Point symbol="triangleDown" /> </Series> <ArgumentAxis defaultVisualRange={defaultVisualRange} customPosition={argumentCustomPosition} offset={argumentOffset} /> <ValueAxis defaultVisualRange={defaultVisualRange} customPosition={valueCustomPosition} offset={valueOffset} endOnTick={false} /> <Legend visible={false} /> </Chart> <div className="options"> <div className="caption">Options</div> <div className="common"> <div className="block left"> <span>Argument Axis</span> <div className="option"> <span>Custom position:</span> <NumberBox value={argumentCustomPosition} showSpinButtons={true} inputAttr={customPositionLabel} onValueChanged={changeArgumentPosition} /> </div> <div className="option"> <span>Offset:</span> <NumberBox value={argumentOffset} showSpinButtons={true} inputAttr={offsetLabel} onValueChanged={changeArgumentOffset} /> </div> </div> <div className="block right"> <span>Value Axis</span> <div className="option"> <span>Custom position:</span> <NumberBox value={valueCustomPosition} showSpinButtons={true} inputAttr={customPositionLabel} onValueChanged={changeValuePosition} /> </div> <div className="option"> <span>Offset:</span> <NumberBox value={valueOffset} showSpinButtons={true} inputAttr={offsetLabel} onValueChanged={changeValueOffset} /> </div> </div> </div> </div> </div> ); } export default App;
import React from 'react'; import ReactDOM from 'react-dom'; import App from './App.tsx'; ReactDOM.render( <App />, document.getElementById('app'), );
export function generateDataSource() { let x1; let x2; let y1; let y2; let i; const ds = []; for (i = 0; i < 20; i += 1) { x1 = random(5, 15); y1 = random(5, 15); ds.push({ x1, y1, x2, y2, }); } for (i = 0; i < 20; i += 1) { x2 = random(5, 15); y2 = random(-15, -5); ds.push({ x1, y1, x2, y2, }); } for (i = 0; i < 20; i += 1) { x2 = random(-15, -5); y2 = random(5, 15); ds.push({ x1, y1, x2, y2, }); } for (i = 0; i < 20; i += 1) { x1 = random(-15, -5); y1 = random(-15, -5); ds.push({ x1, y1, x2, y2, }); } return ds; } function random(min: number, max: number) { return Math.floor(Math.random() * (max - min + 1)) + min; } export const customPositionLabel = { 'aria-label': 'Custom Position' }; export const offsetLabel = { 'aria-label': 'Offset' };
window.exports = window.exports || {}; window.config = { transpiler: 'ts', typescriptOptions: { module: 'system', emitDecoratorMetadata: true, experimentalDecorators: true, jsx: 'react', }, meta: { 'react': { 'esModule': true, }, 'typescript': { 'exports': 'ts', }, 'devextreme/time_zone_utils.js': { 'esModule': true, }, 'devextreme/localization.js': { 'esModule': true, }, 'devextreme/viz/palette.js': { 'esModule': true, }, 'openai': { 'esModule': true, }, }, paths: { 'npm:': 'https://cdn.jsdelivr.net/npm/', 'bundles:': '../../../../bundles/', 'externals:': '../../../../bundles/externals/', 'anti-forgery:': '../../../../shared/anti-forgery/', }, defaultExtension: 'js', map: { 'anti-forgery': 'anti-forgery:fetch-override.js', 'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js', 'typescript': 'npm:typescript@4.2.4/lib/typescript.js', 'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js', 'react': 'npm:react@17.0.2/umd/react.development.js', 'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js', 'prop-types': 'npm:prop-types/prop-types.js', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign', 'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs', 'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs', 'devextreme-quill': 'npm:devextreme-quill@1.7.8/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.2.25/dist/dx-diagram.js', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.67/dist/dx-gantt.js', 'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js', '@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js', 'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3', // SystemJS plugins 'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js', 'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js', // Prettier 'prettier/standalone': 'npm:prettier@2.8.8/standalone.js', 'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js', }, packages: { 'devextreme': { defaultExtension: 'js', }, 'devextreme-react': { main: 'index.js', }, 'devextreme-react/common': { main: 'index.js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/common/core/events/utils': { main: 'index', }, 'devextreme/localization/messages': { format: 'json', defaultExtension: 'json', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', ], babelOptions: { sourceMaps: false, stage0: true, react: true, }, }; window.process = { env: { NODE_ENV: 'production', }, }; System.config(window.config); // eslint-disable-next-line const useTgzInCSB = ['openai'];
import React from 'react'; import ReactDOM from 'react-dom'; import App from './App.js'; ReactDOM.render(<App />, document.getElementById('app'));
export function generateDataSource() { let x1; let x2; let y1; let y2; let i; const ds = []; for (i = 0; i < 20; i += 1) { x1 = random(5, 15); y1 = random(5, 15); ds.push({ x1, y1, x2, y2, }); } for (i = 0; i < 20; i += 1) { x2 = random(5, 15); y2 = random(-15, -5); ds.push({ x1, y1, x2, y2, }); } for (i = 0; i < 20; i += 1) { x2 = random(-15, -5); y2 = random(5, 15); ds.push({ x1, y1, x2, y2, }); } for (i = 0; i < 20; i += 1) { x1 = random(-15, -5); y1 = random(-15, -5); ds.push({ x1, y1, x2, y2, }); } return ds; } function random(min, max) { return Math.floor(Math.random() * (max - min + 1)) + min; } export const customPositionLabel = { 'aria-label': 'Custom Position' }; export const offsetLabel = { 'aria-label': 'Offset' };
<!DOCTYPE html> <html lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.6/css/dx.light.css" /> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script> <script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script> <script type="text/javascript" src="config.js"></script> <script type="text/javascript"> System.import("./index.tsx"); </script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="app"></div> </div> </body> </html>
.options { padding: 20px; margin-top: 20px; background-color: rgba(191, 191, 191, 0.15); } .option { margin-top: 10px; display: flex; align-items: center; justify-content: space-between; } .option > span { margin-right: 20px; } .caption { font-size: 18px; font-weight: 700; } .option > .dx-numberbox { width: 90px; margin-left: auto; } .common { width: 488px; } .block { vertical-align: middle; margin-top: 10px; } .left { display: inline-block; } .right { float: right; } .block > span { font-size: 18px; font-weight: 500; }

Regardless of which automatic axis layout type you use, the Chart Control allows you to apply manual offsets. Specify the offset property in pixels to keep the axis position unchanged when users scroll or zoom the Chart data. The offset property shifts the axis from the specified position as follows:

  • If the axis is horizontal, a negative offset shifts the axis to the top, a positive offset shifts it to the bottom.

  • If the axis is vertical, a negative offset shifts the axis to the left, a positive offset shifts it to the right.

In this demo, you can use controls under the Chart to change the customPosition and offset properties for both axes.

<template>
<div>
<DxChart
id="chart"
:data-source="dataSource"
>
<DxCommonSeriesSettings type="scatter"/>
<DxSeries
argument-field="x1"
value-field="y1"
/>
<DxSeries
argument-field="x2"
value-field="y2"
>
<DxPoint symbol="triangleDown"/>
</DxSeries>
<DxArgumentAxis
:visual-range="[-20, 20]"
:custom-position="argumentPosition"
:offset="argumentOffset"
/>
<DxValueAxis
:visual-range="[-20, 20]"
:custom-position="valuePosition"
:offset="valueOffset"
:end-on-tick="false"
/>
<DxLegend :visible="false"/>
</DxChart>
<div class="options">
<div class="caption">Options</div>
<div class="common">
<div class="block left">
<span>Argument Axis</span>
<div class="option">
<span>Custom position:</span>
<DxNumberBox
v-model:value="argumentPosition"
:show-spin-buttons="true"
:input-attr="{ 'aria-label': 'Custom Position' }"
/>
</div>
<div class="option">
<span>Offset:</span>
<DxNumberBox
v-model:value="argumentOffset"
:show-spin-buttons="true"
:input-attr="{ 'aria-label': 'Offset' }"
/>
</div>
</div>
<div class="block right">
<span>Value Axis</span>
<div class="option">
<span>Custom position:</span>
<DxNumberBox
v-model:value="valuePosition"
:show-spin-buttons="true"
:input-attr="{ 'aria-label': 'Custom position' }"
/>
</div>
<div class="option">
<span>Offset:</span>
<DxNumberBox
v-model:value="valueOffset"
:show-spin-buttons="true"
:input-attr="{ 'aria-label': 'Offset' }"
/>
</div>
</div>
</div>
</div>
</div>
</template>
<script setup lang="ts">
import { ref } from 'vue';
import {
DxChart,
DxCommonSeriesSettings,
DxSeries,
DxPoint,
DxArgumentAxis,
DxValueAxis,
DxLegend,
} from 'devextreme-vue/chart';
import DxNumberBox from 'devextreme-vue/number-box';
import { generateDataSource } from './data.ts';
const argumentPosition = ref(0);
const argumentOffset = ref(0);
const valuePosition = ref(0);
const valueOffset = ref(0);
const dataSource = generateDataSource();
</script>
<style>
.options {
padding: 20px;
margin-top: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
.option {
margin-top: 10px;
display: flex;
align-items: center;
justify-content: space-between;
}
.option > span {
margin-right: 20px;
}
.caption {
font-size: 18px;
font-weight: 700;
}
.option > .dx-numberbox {
width: 90px;
margin-left: auto;
}
.common {
width: 488px;
}
.block {
vertical-align: middle;
margin-top: 10px;
}
.left {
display: inline-block;
}
.right {
float: right;
}
.block > span {
font-size: 18px;
font-weight: 500;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.32/dist/vue.esm-browser.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.68/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
export function generateDataSource() {
let x1 = 0; let x2 = 0; let y1 = 0; let y2 = 0; let
i: number;
const ds: { x1: number; y1: number; x2: number; y2: number }[] = [];
for (i = 0; i < 20; i += 1) {
x1 = random(5, 15);
y1 = random(5, 15);
ds.push({
x1, y1, x2, y2,
});
}
for (i = 0; i < 20; i += 1) {
x2 = random(5, 15);
y2 = random(-15, -5);
ds.push({
x1, y1, x2, y2,
});
}
for (i = 0; i < 20; i += 1) {
x2 = random(-15, -5);
y2 = random(5, 15);
ds.push({
x1, y1, x2, y2,
});
}
for (i = 0; i < 20; i += 1) {
x1 = random(-15, -5);
y1 = random(-15, -5);
ds.push({
x1, y1, x2, y2,
});
}
return ds;
}
function random(min: number, max: number): number {
return Math.floor(Math.random() * (max - min + 1)) + min;
}
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.7/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/typescript@5.9.3/lib/typescript.js"></script>
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>

<dx-chart id="chart" [dataSource]="dataSource">
<dxo-chart-common-series-settings
type="scatter"
></dxo-chart-common-series-settings>
<dxi-chart-series argumentField="x1" valueField="y1"></dxi-chart-series>
<dxi-chart-series argumentField="x2" valueField="y2">
<dxo-chart-point symbol="triangleDown"></dxo-chart-point>
</dxi-chart-series>
<dxo-chart-argument-axis
#argument
[visualRange]="[-20, 20]"
[offset]="0"
[customPosition]="0"
>
</dxo-chart-argument-axis>
<dxi-chart-value-axis
#value
[visualRange]="[-20, 20]"
[endOnTick]="false"
[offset]="0"
[customPosition]="0"
>
</dxi-chart-value-axis>
<dxo-chart-legend [visible]="false"></dxo-chart-legend>
</dx-chart>
<div class="options">
<div class="caption">Options</div>
<div class="common">
<div class="block left">
<span>Argument Axis</span>
<div class="option">
<span>Custom position:</span>
<dx-number-box
[value]="0"
[showSpinButtons]="true"
[(value)]="argument.customPosition"
[inputAttr]="{ 'aria-label': 'Custom Position' }"
>
</dx-number-box>
</div>
<div class="option">
<span>Offset:</span>
<dx-number-box
[value]="0"
[showSpinButtons]="true"
[(value)]="argument.offset"
[inputAttr]="{ 'aria-label': 'Offset' }"
>
</dx-number-box>
</div>
</div>
<div class="block right">
<span>Value Axis</span>
<div class="option">
<span>Custom position:</span>
<dx-number-box
[value]="0"
[showSpinButtons]="true"
[(value)]="value.customPosition"
[inputAttr]="{ 'aria-label': 'Custom Position' }"
>
</dx-number-box>
</div>
<div class="option">
<span>Offset:</span>
<dx-number-box
[value]="0"
[showSpinButtons]="true"
[(value)]="value.offset"
[inputAttr]="{ 'aria-label': 'Offset' }"
>
</dx-number-box>
</div>
</div>
</div>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { DxChartModule, DxNumberBoxModule } from 'devextreme-angular';
import { Service, ScatterData } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
providers: [Service],
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
preserveWhitespaces: true,
imports: [
DxChartModule,
DxNumberBoxModule,
],
})
export class AppComponent {
dataSource: ScatterData[];
constructor(service: Service) {
this.dataSource = service.generateDataSource();
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
.options {
padding: 20px;
margin-top: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
.option {
margin-top: 10px;
display: flex;
align-items: center;
justify-content: space-between;
}
.option > span {
margin-right: 20px;
}
.caption {
font-size: 18px;
font-weight: 700;
}
::ng-deep .option > .dx-numberbox {
width: 90px;
margin-left: auto;
}
::ng-deep .common {
width: 488px;
}
::ng-deep ::ng-deep .block {
vertical-align: middle;
margin-top: 10px;
}
::ng-deep .left {
display: inline-block;
}
::ng-deep .right {
float: right;
}
::ng-deep .block > span {
font-size: 18px;
font-weight: 500;
}
import { Injectable } from '@angular/core';
export class ScatterData {
x1: number;
y1: number;
x2: number;
y2: number;
}
@Injectable()
export class Service {
random(min, max) {
return Math.floor(Math.random() * (max - min + 1)) + min;
}
generateDataSource() {
let x1; let x2; let y1; let y2; let
i;
const ds = [];
for (i = 0; i < 20; i += 1) {
x1 = this.random(5, 15);
y1 = this.random(5, 15);
ds.push({
x1, y1, x2, y2,
});
}
for (i = 0; i < 20; i += 1) {
x2 = this.random(5, 15);
y2 = this.random(-15, -5);
ds.push({
x1, y1, x2, y2,
});
}
for (i = 0; i < 20; i += 1) {
x2 = this.random(-15, -5);
y2 = this.random(5, 15);
ds.push({
x1, y1, x2, y2,
});
}
for (i = 0; i < 20; i += 1) {
x1 = this.random(-15, -5);
y1 = this.random(-15, -5);
ds.push({
x1, y1, x2, y2,
});
}
return ds;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.68',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.15.1/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.68/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"@angular/core": {
"version": "21.2.11"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.9.3"
},
"zone.js": {
"version": "0.15.1"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.7/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.15.1/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>